## deal.ii 9.4.0

=== CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2022 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------


##                                                                    ##
#            The cmake build system for the deal.II project            #
#                                                                      #
#   See doc/readme.html and doc/developers/cmake-internals.html for    #
#   further details on how to use the cmake build system of deal.II.   #
##                                                                    ##

########################################################################
#                                                                      #
#                            Configuration:                            #
#                                                                      #
########################################################################

#
# General configuration for cmake:
#
MESSAGE(STATUS "This is CMake ${CMAKE_VERSION}")
MESSAGE(STATUS "")

CMAKE_MINIMUM_REQUIRED(VERSION 3.3.0)

#
# We support all policy changes up to version 3.3. Thus, explicitly set all
# policies CMP0001 - CMP0054 to new for version 3.3 (and later) to avoid
# some unnecessary warnings.
#
CMAKE_POLICY(VERSION 3.3.0)

IF("${CMAKE_VERSION}" VERSION_LESS "3.11" AND POLICY CMP0037)
  # Allow to override "test" target for quick tests.
  CMAKE_POLICY(SET CMP0037 OLD)
ENDIF()

IF(POLICY CMP0075)
  # Use CMAKE_REQUIRED_LIBRARIES also in include file checks. We set the
  # policy to NEW explicitly in order to avoid spurious configure warnings.
  CMAKE_POLICY(SET CMP0075 NEW)
ENDIF()


LIST(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules/)

#
# Load all macros:
#
FILE(GLOB _macro_files "cmake/macros/*.cmake")
MESSAGE(STATUS "Include ${CMAKE_SOURCE_DIR}/cmake/setup_external_macros.cmake")
INCLUDE(${CMAKE_SOURCE_DIR}/cmake/setup_external_macros.cmake)
FOREACH(_file ${_macro_files})
  MESSAGE(STATUS "Include ${_file}")
  INCLUDE(${_file})
ENDFOREACH()

#
# Avoid verbose "Up-to-date" status information during installation:
#
SET_IF_EMPTY(CMAKE_INSTALL_MESSAGE "LAZY")

#
# Check for the existence of various optional folders:
#
IF(EXISTS ${CMAKE_SOURCE_DIR}/bundled/CMakeLists.txt)
  SET(DEAL_II_HAVE_BUNDLED_DIRECTORY TRUE)
ENDIF()

IF(EXISTS ${CMAKE_SOURCE_DIR}/doc/CMakeLists.txt)
  SET(DEAL_II_HAVE_DOC_DIRECTORY TRUE)
ENDIF()

IF(EXISTS ${CMAKE_SOURCE_DIR}/tests/CMakeLists.txt)
  SET(DEAL_II_HAVE_TESTS_DIRECTORY TRUE)
ENDIF()

#
# We have to initialize some cached variables before PROJECT is called, so
# do it at this point:
#
VERBOSE_INCLUDE(${CMAKE_SOURCE_DIR}/cmake/setup_cached_variables.cmake)

#
# Now, set the project and set up the rest:
#
PROJECT(deal.II CXX C)
ENABLE_LANGUAGE_OPTIONAL(Fortran)

VERBOSE_INCLUDE(${CMAKE_SOURCE_DIR}/cmake/setup_deal_ii.cmake)

VERBOSE_INCLUDE(${CMAKE_SOURCE_DIR}/cmake/setup_compiler_flags.cmake)

#
# Include information about bundled libraries:
#
IF(DEAL_II_HAVE_BUNDLED_DIRECTORY)
  VERBOSE_INCLUDE(${CMAKE_SOURCE_DIR}/bundled/setup_bundled.cmake)
ENDIF()

#
# Run all system checks:
#
FILE(GLOB _check_files "cmake/checks/*.cmake")
LIST(SORT _check_files)
FOREACH(_file ${_check_files})
  VERBOSE_INCLUDE(${_file})
ENDFOREACH()

#
# Feature configuration:
#
FILE(GLOB _configure_files "cmake/configure/configure_*.cmake")
LIST(SORT _configure_files) # make sure to include in alphabetical order
FOREACH(_file ${_configure_files})
  VERBOSE_INCLUDE(${_file})
ENDFOREACH()

#
# Finalize the configuration:
#
VERBOSE_INCLUDE(${CMAKE_SOURCE_DIR}/cmake/setup_cpack.cmake)
VERBOSE_INCLUDE(${CMAKE_SOURCE_DIR}/cmake/setup_custom_targets.cmake)
VERBOSE_INCLUDE(${CMAKE_SOURCE_DIR}/cmake/setup_finalize.cmake)
VERBOSE_INCLUDE(${CMAKE_SOURCE_DIR}/cmake/setup_write_config.cmake)

########################################################################
#                                                                      #
#                     Compilation and installation:                    #
#                                                                      #
########################################################################

MESSAGE(STATUS "")
MESSAGE(STATUS "Configuring done. Proceed to target definitions now.")

ADD_SUBDIRECTORY(cmake/scripts)
ADD_SUBDIRECTORY(include)

IF(DEAL_II_HAVE_DOC_DIRECTORY)
  ADD_SUBDIRECTORY(doc) # has to be included after include
ENDIF()

IF(DEAL_II_HAVE_BUNDLED_DIRECTORY)
  ADD_SUBDIRECTORY(bundled)
ENDIF()
ADD_SUBDIRECTORY(source) # has to be included after bundled

ADD_SUBDIRECTORY(cmake/config) # has to be included after source
ADD_SUBDIRECTORY(examples)

ADD_SUBDIRECTORY(contrib/utilities)

IF(DEAL_II_HAVE_TESTS_DIRECTORY)
  ADD_SUBDIRECTORY(tests)
ENDIF()

ADD_SUBDIRECTORY(contrib/python-bindings) # has to be included after tests

#
# And finally, print the configuration:
#
FILE(READ ${CMAKE_BINARY_DIR}/summary.log DEAL_II_LOG_SUMMARY)
MESSAGE("${DEAL_II_LOG_SUMMARY}")

=== debian/changelog ===
deal.ii (9.4.0-2) unstable; urgency=medium

  [ Matthias Maier ]
  * Force -std=c++17

  [ Frédéric Bonnard ]
  * Link with -Bsymbolic-functions on ppc64el to avoid FTBFS
    (Closes: #1022973)

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Sat, 05 Nov 2022 15:39:48 +0000

deal.ii (9.4.0-1) unstable; urgency=medium

  [ Matthias Maier ]
  * New upstream release
    - support new OneAPI in TBB (Closes: #1011655)
  * Re-enable Sundials IDA quick test

  [ Graham Inggs ]
  * Stop limiting to 2 parallel build jobs
  * Bump Standards-Version to 4.6.1, no changes

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Mon, 04 Jul 2022 16:49:47 +0000

deal.ii (9.3.2-1) unstable; urgency=medium

  * New upstream release
  * Disable Sundials IDA quick test

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Wed, 23 Mar 2022 08:56:58 +0000

=== debian/control ===
Source: deal.ii
Section: libs
Priority: optional
Standards-Version: 4.6.1
Rules-Requires-Root: no
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>,
           Graham Inggs <ginggs@debian.org>
Vcs-Browser: https://salsa.debian.org/science-team/deal.ii
Vcs-Git: https://salsa.debian.org/science-team/deal.ii.git
Homepage: http://www.dealii.org/
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               gmsh,
               graphviz,
               libadolc-dev (>= 2.6.4),
               libarpack2-dev,
               libassimp-dev,
               libboost-iostreams-dev,
               libboost-math-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcgal-dev,
               libgmsh-dev,
               libgsl-dev,
               libhdf5-dev,
               libhdf5-mpi-dev,
               liblapack-dev,
               libmetis-dev,
               libmuparser-dev,
               libocct-data-exchange-dev,
               libocct-foundation-dev,
               libocct-ocaf-dev,
               libocct-visualization-dev,
               libp4est-dev (>= 2.0),
               libscalapack-mpi-dev,
               libsuitesparse-dev,
               libsundials-dev (>= 5.7.0),
               libtbb-dev,
               mpi-default-dev,
               petsc-dev,
               python3-minimal:native,
               slepc-dev,
               trilinos-all-dev,
               zlib1g-dev

Package: libdeal.ii-dev
Section: libdevel
Architecture: any
Depends: libadolc-dev (>= 2.6.4),
         libarpack2-dev,
         libassimp-dev,
         libboost-iostreams-dev,
         libboost-math-dev,
         libboost-serialization-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libcgal-dev,
         libdeal.ii-9.4.0 (= ${binary:Version}),
         libgmsh-dev,
         libgsl-dev,
         libhdf5-dev,
         libhdf5-mpi-dev,
         liblapack-dev,
         libmetis-dev,
         libmuparser-dev,
         libocct-data-exchange-dev,
         libocct-foundation-dev,
         libocct-ocaf-dev,
         libocct-visualization-dev,
         libp4est-dev (>= 2.0),
         libscalapack-mpi-dev,
         libsuitesparse-dev,
         libsundials-dev (>= 5.7.0),
         libtbb-dev,
         mpi-default-dev,
         petsc-dev,
         slepc-dev,
         trilinos-all-dev,
         zlib1g-dev,
         ${misc:Depends}
Recommends: cmake, g++, numdiff
Description: Differential Equations Analysis Library - development files
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the development files.

Package: libdeal.ii-9.4.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gmsh
Pre-Depends: ${misc:Pre-Depends}
Description: Finite Element Differential Equations Analysis Library
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the shared libraries.

Package: libdeal.ii-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: fonts-mathjax-extras, libjs-mathjax, ${misc:Depends}
Description: Differential Equations Analysis Library - html doc. and examples
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the documentation and examples.

=== debian/rules ===
#! /usr/bin/make -f

export OMPI_MCA_plm_rsh_agent=/bin/false
export OMPI_MCA_rmaps_base_oversubscribe=1

ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el))
CONFIGURE_LINKER_FLAGS=-DDEAL_II_LINKER_FLAGS="-Wl,-Bsymbolic-functions"
endif

%:
	dh $@

# The following (optional) dependencies are missing because they are not
# packaged in debian:
#   arborx (https://github.com/arborx/ArborX)
#   ginkgo (https://ginkgo-project.github.io/)
#   symengine (https://github.com/sympy/symengine)
override_dh_auto_configure:
	dh_auto_configure -- \
	-DDEAL_II_CXX_FLAGS="-std=c++17 -Wno-nonnull-compare -Wno-address" \
	$(CONFIGURE_LINKER_FLAGS) \
	-DCMAKE_PREFIX_PATH="/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/openmpi;/usr/include/hdf5/openmpi" \
	-DCMAKE_BUILD_TYPE=DebugRelease \
	-DDEAL_II_ALLOW_AUTODETECTION=OFF \
	-DDEAL_II_ALLOW_BUNDLED=OFF \
	-DDEAL_II_ALLOW_PLATFORM_INTROSPECTION=OFF \
	-DDEAL_II_COMPILE_EXAMPLES=OFF \
	-DDEAL_II_COMPONENT_DOCUMENTATION=ON \
	-DDEAL_II_DOXYGEN_USE_MATHJAX=ON \
	-DDEAL_II_DOXYGEN_USE_ONLINE_MATHJAX=OFF \
	-DMATHJAX_PATH="/usr/share/javascript/mathjax" \
	-DDEAL_II_COMPONENT_EXAMPLES=ON \
	-DDEAL_II_HAVE_FP_EXCEPTIONS=FALSE \
	-DDEAL_II_WITH_ADOLC=ON \
	-DDEAL_II_WITH_ARPACK=ON \
	-DDEAL_II_WITH_ASSIMP=ON \
	-DDEAL_II_WITH_BOOST=ON \
	-DDEAL_II_WITH_CGAL=ON \
	-DDEAL_II_WITH_COMPLEX_VALUES=ON \
	-DDEAL_II_WITH_GMSH=ON \
	-DDEAL_II_WITH_GSL=ON \
	-DDEAL_II_WITH_HDF5=ON \
	-DDEAL_II_WITH_KOKKOS=ON \
	-DDEAL_II_WITH_LAPACK=ON \
	-DDEAL_II_WITH_METIS=ON \
	-DDEAL_II_WITH_MPI=ON \
	-DDEAL_II_WITH_MUPARSER=ON \
	-DDEAL_II_WITH_OPENCASCADE=ON \
	-DDEAL_II_WITH_P4EST=ON \
	-DDEAL_II_WITH_PETSC=ON \
	-DDEAL_II_WITH_SCALAPACK=ON \
	-DDEAL_II_WITH_SUNDIALS=ON \
	-DDEAL_II_WITH_SLEPC=ON \
	-DDEAL_II_WITH_TBB=ON \
	-DDEAL_II_WITH_TRILINOS=ON \
	-DDEAL_II_WITH_UMFPACK=ON \
	-DDEAL_II_WITH_ZLIB=ON \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF \
	-DDEAL_II_BASE_NAME="deal.ii" \
	-DDEAL_II_DOCHTML_RELDIR=share/doc/libdeal.ii-doc/html \
	-DDEAL_II_DOCREADME_RELDIR=share/doc/libdeal.ii-doc \
	-DDEAL_II_EXAMPLES_RELDIR=share/doc/libdeal.ii-doc/examples \
	-DDEAL_II_LIBRARY_RELDIR=lib/$(DEB_HOST_MULTIARCH) \
	-DDEAL_II_PROJECT_CONFIG_RELDIR=share/cmake/deal.II \
	-DDEAL_II_SHARE_RELDIR=share/deal.ii/

override_dh_auto_test:
	dh_auto_test --max-parallel=1

TMP_DOC := debian/tmp/usr/share/doc/libdeal.ii-doc
override_dh_auto_install:
	dh_auto_install
	# Copy over all external html resources:
	cp -r doc/doxygen/deal.II/images $(TMP_DOC)/html/doxygen/deal.II/
	# Replace links external deal.II html resources by local links:
	sed -i 's#"https\?://www.dealii.org/images/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/step_*.html \
		$(TMP_DOC)/html/doxygen/deal.II/class*.html \
		$(TMP_DOC)/html/doxygen/deal.II/namespaceGridGenerator_1_1Airfoil.html
	# Replace zenodo links:
	sed -i -e 's#"https://zenodo.org/badge/DOI/10.5281/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/step_*.html \
		$(TMP_DOC)/html/doxygen/deal.II/class*.html
	sed -i -e 's#"https://upload.wikimedia.org/wikipedia/commons/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/group_*.html
	# Remove external links to the W3C validator icon:
	find $(TMP_DOC)/html \
		-type f -name '*.html' -exec sed -i 's#\(<img.*w3.org.*\)</a>#</a>#' {} \;
	# Remove superfluous license file
	rm $(TMP_DOC)/LICENSE.md

override_dh_compress:
	# Do not compress example source code, and icons:
	dh_compress -X.cc -X.ico

override_dh_dwz:
	# Double up the limit of debug information entries:
	dh_dwz -- -L 100000000

VERSION := 9.4.0
get-orig-source:
	wget --no-clobber -O deal.ii-$(VERSION).tar.gz https://github.com/dealii/dealii/releases/download/v$(VERSION)/dealii-$(VERSION).tar.gz
	wget --no-clobber -O deal.ii-doc-$(VERSION).tar.gz https://github.com/dealii/dealii/releases/download/v$(VERSION)/dealii-$(VERSION)-offline_documentation.tar.gz
	mkdir deal.ii-$(VERSION)
	tar --strip-components=1 -C deal.ii-$(VERSION) -xzf deal.ii-$(VERSION).tar.gz
	mkdir -p deal.ii-$(VERSION)/doc/doxygen/deal.II
	tar -C deal.ii-$(VERSION) -xzf deal.ii-doc-$(VERSION).tar.gz doc/doxygen/deal.II/images
	set -e; cd deal.ii-$(VERSION); \
		rm -rf bundled
	tar -cJf deal.ii_$(VERSION).orig.tar.xz deal.ii-$(VERSION)
	rm -rf deal.ii-$(VERSION)
